<?xml version="1.0" encoding="UTF-8"?>
<?eclipse version="3.0"?>
<plugin>
   <extension-point id="deviceEditor" name="Device Editor" schema="schema/org_eclipse_mtj_ui_deviceEditor.exsd"/>
   <extension-point id="jadAttributes" name="JAD Attributes" schema="schema/jadAttributes.exsd"/>
   <extension-point id="jadEditorPages" name="JAD Editor Pages" schema="schema/jadEditorPages.exsd"/>
   <extension
         point="org.eclipse.ui.newWizards">
      <category
            name="%category.j2me.name"
            id="mtj.category">
      </category>
      <wizard
            name="%wizard.newJ2MEProject.label"
            icon="icons/newjprj_wiz_m_sm.gif"
            category="mtj.category"
            class="org.eclipse.mtj.ui.internal.wizards.project.NewMIDLetProjectWizard"
            project="true"
            finalPerspective="org.eclipse.mtj.ui.MtjPerspective"
            id="org.eclipse.mtj.ui.wizards.NewJ2MEProjectWizard">
         <description>
            %wizard.newJ2MEProject.description
         </description>
      </wizard>
      <wizard
            name="%wizard.newMidlet.label"
            icon="icons/newclass_wiz_green.gif"
            category="mtj.category"
            finalPerspective="org.eclipse.jdt.ui.JavaPerspective"
            id="org.eclipse.mtj.ui.wizards.NewMidletWizard">
         <class class="org.eclipse.mtj.ui.internal.wizards.midlet.NewMidletWizard">
         	<parameter name="javatype" value="true"/>
         </class>
         <description>
            %wizard.newMidlet.description
         </description>
      </wizard>
   </extension>
   <extension
         point="org.eclipse.ui.importWizards">
      <category
            name="%category.j2me.name"
            id="mtj.category">
      </category>
      <wizard
            name="%importWizards.EclipseMEProject.label"
            icon="icons/importdev_wiz.gif"
            category="mtj.category"            
            class="org.eclipse.mtj.ui.internal.wizards.importer.eclipseme.ImportEclipseMEProjectWizard"
            id="org.eclipse.mtj.ui.wizards.import.EclipseMEProject">
         <description>
            %importWizards.EclipseMEProject.description
         </description>
      </wizard>
   </extension>
   <extension
         point="org.eclipse.ui.preferencePages">
      <page
            name="%preference.j2me.name"
            class="org.eclipse.mtj.ui.internal.preferences.J2MEPreferencePage"
            id="org.eclipse.mtj.ui.preferences.J2MEPreferencePage">
      </page>
      <page
            name="%preference.j2meDevices.name"
            category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
            class="org.eclipse.mtj.ui.internal.preferences.DeviceManagementPreferencePage"
            id="org.eclipse.mtj.ui.preferences.deviceManagementPreferencePage">
      </page>
      <page
            name="%preference.j2meProject.name"
            category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
            class="org.eclipse.mtj.ui.internal.preferences.NewJ2MEProjectPreferencePage"
            id="org.eclipse.mtj.ui.internal.preferences.NewJ2MEProjectPreferencePage">
      </page>
      <page
      		name="%preference.j2me.packaging.name"
      		category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
      		class="org.eclipse.mtj.ui.internal.preferences.PackagingPreferencePage"
      		id="org.eclipse.mtj.ui.preferences.PackagingPreferences" />
       <page
            name="%preference.j2me.preverification.name"
            category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
            class="org.eclipse.mtj.ui.internal.preferences.PreverificationPreferencePage"
            id="org.eclipse.mtj.ui.preferences.PreverificationPreferencePage">
      </page>
      <page
            name="%preference.j2meota.name"
            category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
            class="org.eclipse.mtj.ui.internal.preferences.J2MEOTAPreferencePage"
            id="org.eclipse.mtj.ui.preferences.J2MEOTAPreferencePage">
      </page>
      <page
            name="%preference.j2meobfuscation.name"
            category="org.eclipse.mtj.ui.preferences.PackagingPreferences"
            class="org.eclipse.mtj.ui.internal.preferences.ObfuscationPreferencePage"
            id="org.eclipse.mtj.ui.preferences.ObfuscationPreferencePage">
      </page>
   </extension>
   <extension
         point="org.eclipse.ui.popupMenus">
      <objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.javaProject">
         <filter
               name="projectNature"
               value="org.eclipse.jdt.core.javanature">
         </filter>
         <menu
               label="%menu.project.j2me"
               path="additions"
               id="org.eclipse.mtj.ui.popup.menu">
            <separator
                  name="dummy">
            </separator>
            <separator
                  name="group">
            </separator>
         </menu>
       </objectContribution>
      <objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.j2meProject">
         <menu
               label="%menu.project.j2me"
               path="additions"
               id="org.eclipse.mtj.ui.popup.menu">
            <separator name="convert" />
            <separator name="package" />
            <separator name="export" />
         </menu>
      </objectContribution>
      <objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.j2meProject">
         	<visibility>
         		<and>
					<objectState name="nature" value="org.eclipse.mtj.core.nature"/>
					<not>
						<objectState name="nature" value="org.eclipse.mtj.core.preprocessedNature"/>
	   				</not>
	   			</and>
  			</visibility>
         <action
               label="%menu.j2me.createObfuscatedPackage"
               class="org.eclipse.mtj.ui.internal.actions.CreateObfuscatedPackageAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/package"
               id="org.eclipse.mtj.ui.actions.createobfuscatedpackage">
         </action>
         <action
               label="%menu.j2me.createPackage"
               class="org.eclipse.mtj.ui.internal.actions.CreatePackageAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/package"
               id="org.eclipse.mtj.ui.actions.createpackage">
         </action>
         <action
               label="%menu.j2me.exportAntenna"
               class="org.eclipse.mtj.ui.internal.actions.AntennaBuildExportAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/export"
               id="org.eclipse.mtj.ui.actions.antennaexport">
         </action>
      </objectContribution>
      <objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.javaProject.convert">
			<visibility>
				<not>
					<objectState name="nature" value="org.eclipse.mtj.core.nature"/>
   				</not>
  			</visibility>
         <action
               label="%menu.j2me.convertProject"
               class="org.eclipse.mtj.ui.internal.actions.ConvertToMidletSuiteAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/convert"
               id="org.eclipse.mtj.ui.actions.convertproject">
         </action>
      </objectContribution>
      <!--//FIXME Preprocessor is not yet available-->
      <!--objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.project.disablePreprocessing">
			<visibility>
				<and>
					<objectState name="nature" value="org.eclipse.mtj.core.nature"/>
					<objectState name="nature" value="org.eclipse.mtj.core.preprocessingNature"/>					
	   			</and>
  			</visibility>
         <action
               label="Disable Preprocessing"
               class="org.eclipse.mtj.ui.internal.actions.DisablePreprocessingAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/convert"
               id="org.eclipse.mtj.ui.actions.disablepreprocessing">
         </action>
      </objectContribution>
      <objectContribution
            objectClass="org.eclipse.core.resources.IProject"
            adaptable="true"
            id="org.eclipse.mtj.ui.action.popup.project.enablePreprocessing">
			<visibility>
				<and>
					<objectState name="nature" value="org.eclipse.mtj.core.nature"/>
					<not>
						<objectState name="nature" value="org.eclipse.mtj.core.preprocessingNature"/>					
	   				</not>
	   			</and>
  			</visibility>
         <action
               label="Enable Preprocessing"
               class="org.eclipse.mtj.ui.internal.actions.EnablePreprocessingAction"
               menubarPath="org.eclipse.mtj.ui.popup.menu/convert"
               id="org.eclipse.mtj.ui.actions.enablepreprocessing">
         </action>
      </objectContribution-->
   </extension>
   <extension
         id="org.eclipse.mtj.ui.editors"
         name="Editors"
         point="org.eclipse.ui.editors">
      <editor
            class="org.eclipse.mtj.ui.internal.editor.jad.form.JADFormEditor"
            default="true"
            filenames="Application Descriptor"
            icon="icons/newjprj_wiz_m_sm.gif"
            id="org.eclipse.mtj.ui.editor.JadEditor"
            name="%editor.jad">
      </editor>
      <editor
            class="org.eclipse.mtj.ui.internal.editor.jad.source.JADSourceEditor"
            default="true"
            extensions="jad"
            icon="icons/page_obj.gif"
            id="org.eclipse.mtj.ui.editor.JadSourceEditor"
            name="%editor.jad">
      </editor>
   </extension>
   <extension
         id="org.eclipse.mtj.launching.launchConfigTabGroups"
         name="Launch Config Tab Groups"
         point="org.eclipse.debug.ui.launchConfigurationTabGroups">
      <launchConfigurationTabGroup
            class="org.eclipse.mtj.ui.internal.launching.ToolkitEmulatorTabGroup"
            description="%launch.configuration.description"
            id="toolkitEmulatorTabGroup"
            type="MTJ.emulatorLaunchConfigurationType">
      </launchConfigurationTabGroup>
   </extension>
   <extension
         point="org.eclipse.debug.ui.launchConfigurationTypeImages">
      <launchConfigurationTypeImage
            icon="icons/cellphone_icon.gif"
            configTypeID="MTJ.emulatorLaunchConfigurationType"
            id="MTJ.emulatorLaunchConfigTypeImage">
      </launchConfigurationTypeImage>
   </extension>
   <extension
         id="org.eclipse.mtj.ui.propertyPages"
         name="Property Pages"
         point="org.eclipse.ui.propertyPages">
      <page
            name="%category.j2me.name"
            class="org.eclipse.mtj.ui.internal.properties.J2MEProjectPropertiesPage"
            id="org.eclipse.mtj.project.J2MEPropertiesPage">
         <filter
               name="projectNature"
               value="org.eclipse.mtj.core.nature">
         </filter>
         <enabledWhen>
            <adapt
                  type="org.eclipse.core.resources.IProject">
            </adapt>
         </enabledWhen>
      </page>
      <page category="org.eclipse.mtj.project.J2MEPropertiesPage"
            class="org.eclipse.mtj.ui.internal.properties.J2MESigningPropertiesPage"
            id="org.eclipse.mtj.project.J2MESigningPropertiesPage"
            name="%category.j2me.signing.name">
         <filter
               name="projectNature"
               value="org.eclipse.mtj.core.nature">
         </filter>
         <enabledWhen>
            <adapt
                  type="org.eclipse.core.resources.IProject">
            </adapt>
         </enabledWhen>
      </page>
      <page category="org.eclipse.mtj.project.J2MEPropertiesPage"
            class="org.eclipse.mtj.ui.internal.properties.ProjectPackagingPropertiesPage"
            id="org.eclipse.mtj.project.ProjectPackagingPropertiesPage"
            name="%properties.packaging.name">
         <filter
               name="projectNature"
               value="org.eclipse.mtj.core.nature">
         </filter>
                  <enabledWhen>
            <adapt
                  type="org.eclipse.core.resources.IProject">
            </adapt>
         </enabledWhen>
      </page>
      <page category="org.eclipse.mtj.project.J2MEPropertiesPage"
            class="org.eclipse.mtj.ui.internal.properties.ProjectObfuscationPropertiesPage"
            id="org.eclipse.mtj.project.ProjectObfuscationPropertiesPage"
            name="%properties.obfuscation.name">
         <filter
               name="projectNature"
               value="org.eclipse.mtj.core.nature">
         </filter>
         <enabledWhen>
            <adapt
                  type="org.eclipse.core.resources.IProject">
            </adapt>
         </enabledWhen>
      </page>
      <page category="org.eclipse.mtj.project.J2MEPropertiesPage"
            class="org.eclipse.mtj.ui.internal.properties.ProjectPreverificationPropertiesPage"
            id="org.eclipse.mtj.project.ProjectPreverificationPropertiesPage"
            name="%properties.preverification.name">
         <filter
               name="projectNature"
               value="org.eclipse.mtj.core.nature">
         </filter>
                  <enabledWhen>
            <adapt
                  type="org.eclipse.core.resources.IProject">
            </adapt>
         </enabledWhen>
      </page>
   </extension>
   <extension
         point="org.eclipse.debug.ui.launchShortcuts">
      <shortcut
            class="org.eclipse.mtj.ui.internal.launching.EmulatorLaunchShortcut"
            icon="icons/cellphone_icon.gif"
            id="org.eclipse.mtj.launchShortcuts"
            label="%launch.emulator.shortcut"
            modes="run,debug">
            
         <contextualLaunch>
            <enablement>
               <with variable="selection">
                  <count value="1" />
               		<iterate>
		             <and>
		               <adapt type="org.eclipse.jdt.core.IJavaElement">
		                 <test property="org.eclipse.jdt.core.isInJavaProject"/>
		               </adapt>
		               <test property="org.eclipse.jdt.launching.extendsClass" args="javax.microedition.midlet.MIDlet"/>
		              </and>
               		</iterate>
               </with>
            </enablement>
         </contextualLaunch>
         <perspective
               id="org.eclipse.mtj.ui.MtjPerspective">
         </perspective>
         
         <perspective
               id="org.eclipse.jdt.ui.JavaPerspective">
         </perspective>
         <perspective
               id="org.eclipse.jdt.ui.JavaHierarchyPerspective">
         </perspective>
         <perspective
               id="org.eclipse.jdt.ui.JavaBrowsingPerspective">
         </perspective>
         <perspective
               id="org.eclipse.debug.ui.DebugPerspective">
         </perspective>
      </shortcut>
      <shortcut
            label="%launch.emulator.shortcut.jad"
            icon="icons/cellphone_icon.gif"
            modes="run,debug"
            class="org.eclipse.mtj.ui.internal.launching.JadLaunchShortcut"
            id="org.eclipse.mtj.jadLaunchShortcuts">
         <contextualLaunch>
            <enablement>
               <with variable="selection">
                  <count value="1" />
               		<iterate>
		             <or>
		              <adapt type="org.eclipse.core.resources.IFile">
		                  <and>
			                 <test property="org.eclipse.core.resources.projectNature" value="org.eclipse.mtj.core.nature"/>
			                 <test property="org.eclipse.core.resources.name" value="Application Descriptor"/>
		                  </and>
		              </adapt>
			          <adapt type="org.eclipse.core.resources.IProject">
			          	<test property="org.eclipse.core.resources.projectNature" value="org.eclipse.mtj.core.nature"/>
			          </adapt>
		             </or>
               	    </iterate>
               </with>
            </enablement>
         </contextualLaunch>
         <description
               description="%launch.emulator.shortcut.jad.description"
               mode="run">
         </description>
         <description
               description="%debug.emulator.shortcut.jad.description"
               mode="debug">
         </description>
         
      </shortcut>
   </extension>
	 <extension
	       point="org.eclipse.debug.core.statusHandlers">
	    <statusHandler
	          code="100"
	          class="org.eclipse.mtj.ui.internal.statusHandlers.OTANoMidletsHandler"
	          id="org.eclipse.mtj.statusHandler.otaNoMidlets"
	          plugin="org.eclipse.mtj.core"/>
	    <statusHandler
	          code="101"
	          class="org.eclipse.mtj.ui.internal.statusHandlers.ObfuscationErrorHandler"
	          id="org.eclipse.mtj.statusHandler.ObfuscationErrorHandler"
	          plugin="org.eclipse.mtj.core"/>
	    <statusHandler
	          code="102"
	          class="org.eclipse.mtj.ui.internal.statusHandlers.CouldNotFindJarToolHandler"
	          id="org.eclipse.mtj.statusHandler.CouldNotFindJarToolHandler"
	          plugin="org.eclipse.mtj.core"/>
        <statusHandler
              code="103"
              class="org.eclipse.mtj.ui.internal.statusHandlers.SignaturePasswordHandler"
              id="org.eclipse.mtj.statusHandler.SignaturePasswordHandler"
              plugin="org.eclipse.mtj.core"/>
           
       <statusHandler
	          code="104"
	          class="org.eclipse.mtj.ui.internal.statusHandlers.DebuggerSettingCheckHandler"
	          id="org.eclipse.mtj.statusHandler.DebuggerSettingCheckHandler"
	          plugin="org.eclipse.mtj.core"/>
	 </extension>
	<extension point="org.eclipse.core.runtime.preferences">
		<initializer class="org.eclipse.mtj.ui.internal.MTJUIPreferenceInitializer"/>
	</extension>
	<extension point="org.eclipse.help.contexts" >
		<contexts	file="contextHelp.xml"
					plugin="org.eclipse.mtj.ui" />
	</extension>

 
 <!--//FIXME Preprocessor is not yet available-->
 <!-- Preprocessor Support -->
    <!--extension
         point="org.eclipse.ui.preferencePages">
      <page
            name="%preference.j2mesymbols.name"
            category="org.eclipse.mtj.ui.preferences.J2MEPreferencePage"
            class="org.eclipse.mtj.ui.internal.preferences.SymbolDefinitionsPreferencePage"
            id="org.eclipse.mtj.ui.preferences.symbolDefinitionsPreferencePage">
      </page>
   </extension-->
    <extension
          point="org.eclipse.ui.console.consoleFactories">
       <consoleFactory
             class="org.eclipse.mtj.ui.console.BuilderConsoleFactory"
             label="MTJ Build Console">
       </consoleFactory>
    </extension>
    <extension
          point="org.eclipse.ui.perspectives">
       <perspective
             class="org.eclipse.mtj.ui.MtjPerspectiveFactory"
             icon="icons/class_obj_green.gif"
             id="org.eclipse.mtj.ui.MtjPerspective"
             name="%mtjPerspectiveName">
          <description>
             %mtj.perspective.description
          </description>
       </perspective>
    </extension>
    
     <extension
          point="org.eclipse.mtj.ui.jadEditorPages">
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADRequiredPropertiesEditorPage"
       		priority="10"/>
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADMidletsEditorPage"
       		priority="20"/>
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADOptionalPropertiesEditorPage"
       		priority="30"/>
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADOTAPropertiesEditorPage"
       		priority="40"/>
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADPushRegistryEditorPage"
       		priority="50"/>
       <jadEditorPage 
       		class="org.eclipse.mtj.ui.internal.editor.jad.form.JADUserDefinedPropertiesEditorPage"
       		priority="2147483647"/>
    </extension>
    
    <extension
          point="org.eclipse.mtj.ui.jadAttributes">
       <jadAttributes pageID="required">
       		<jadDescriptorsProvider
       			class="org.eclipse.mtj.ui.internal.editor.jad.form.RequiredJADDesciptorsProvider"/>
       </jadAttributes>
    </extension>
    
    <extension
          point="org.eclipse.mtj.ui.jadAttributes">
       <jadAttributes pageID="ota">
       		<jadDescriptorsProvider
       			class="org.eclipse.mtj.ui.internal.editor.jad.form.OTAJADDescriptorsProvider"/>
       </jadAttributes>
    </extension>
    
    <extension
          point="org.eclipse.mtj.ui.jadAttributes">
       <jadAttributes pageID="optional">
       		<jadDescriptorsProvider
       			class="org.eclipse.mtj.ui.internal.editor.jad.form.OptionalJADDescriptorsProvider"/>
       </jadAttributes>
    </extension>
    
 </plugin>
